<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { NextStep } from '~/components/common/index';
import { getPageMetadata } from '~/common/meta';

import MktoForm from '@/components/calculator/mktoForm.vue';

import TabControls from '@/components/calculator/tab-controls.vue';

import costROICalculator from '~/components/calculator/cost-roi.vue';
import timeROICalculator from '~/components/calculator/time-roi.vue';

export default Vue.extend({
  components: {
    NextStep,
    costROICalculator,
    timeROICalculator,
    TabControls,
    MktoForm,
  },
  nuxtI18n: false,
  async asyncData({ $content }) {
    const doc = await $content('calculator/roi/index').fetch();
    return { doc };
  },
  data() {
    return {
      tabData: [
        {
          tabName: 'Save money',
          tabId: 'cost',
        },
        {
          tabName: 'Save time',
          tabId: 'time',
        },
      ],
      selectedTab: null,
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).doc, this.$route.path);
  },
  beforeMount() {
    if (this.$route.query.calculator === 'time') {
      this.selectedTab = 1;
    } else {
      this.selectedTab = 0;
    }

    if (this.$route.query.utm_partnerid) {
      sessionStorage.setItem('partnerId', this.$route.query.utm_partnerid);
    } else if (!this.$route.query.utm_partnerid) {
      sessionStorage.removeItem('partnerId'); // if this already exists in a user's sessionstorage, remove it if they did not visit a page with unique partner id
    }
  },
});
</script>
<template>
  <div>
    <script src="//page.gitlab.com/js/forms2/js/forms2.min.js"></script>

    <SlpContainer>
      <section class="calculator-wrapper">
        <SlpTypography tag="h1" variant="heading2-bold"
          >How much is your toolchain costing you?</SlpTypography
        >
        <div>
          <TabControls :tab-data="tabData" :selected-tab-param="selectedTab">
            <template #0>
              <costROICalculator
                id="cost-panel"
                class="cost-calculator"
                aria-labelledby="cost-tab"
                :tooltip-data="doc.tooltips"
                :premium-features="doc.premium_features"
                :ultimate-features="doc.ultimate_features"
                :spend-tooltip="doc.currentSpendTooltip"
              />
            </template>
            <template #1>
              <timeROICalculator
                id="time-panel"
                class="time-calculator"
                aria-labelledby="time-tab"
                :tooltip-data="doc.tooltips"
                :premium-features="doc.premium_features"
                :ultimate-features="doc.ultimate_features"
              />
            </template>
          </TabControls>
          <MktoForm v-show="$route.query.step == 3" />
        </div>
      </section>
      <section class="time-card slp-mb-24">
        <div class="img-wrapper">
          <nuxt-img :src="doc.time_card.img_url" alt="" aria-hidden="true" />
        </div>
        <div class="content">
          <SlpTypography tag="h3" variant="heading5" class="slp-mb-16">
            {{ doc.time_card.text }}
          </SlpTypography>
          <SlpButton
            variant="primary"
            :href="doc.time_card.cta.url"
            :data-ga-name="doc.time_card.cta.data_ga_name"
            :data-ga-location="doc.time_card.cta.data_ga_location"
          >
            {{ doc.time_card.cta.text }}
            <SlpIcon name="chevron-lg-right" variant="product" />
          </SlpButton>
        </div>
      </section>
      <section class="cards">
        <a
          v-for="card in doc.cards"
          :key="card.title"
          class="card"
          :href="card.link_url"
          :data-ga-name="card.data_ga_name"
          :data-ga-location="card.data_ga_location"
        >
          <SlpIcon
            v-if="card.icon"
            size="lg"
            :name="card.icon.name"
            :alt="card.icon.alt"
            :variant="card.icon.variant"
          />
          <SlpTypography tag="h3" variant="heading3">{{
            card.title
          }}</SlpTypography>
          <span class="button">
            {{ card.link_text }}
            <SlpIcon variant="product" name="chevron-lg-right" />
          </span>
        </a>
      </section>
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.calculator-wrapper {
  padding-top: $spacing-64;
  margin-bottom: $spacing-96;

  @media (max-width: $breakpoint-md) {
    margin-top: $spacing-24;

    padding-top: $spacing-16;
  }

  h1 {
    text-align: center;
    margin: 0 auto $spacing-48 auto;
    display: block;
    max-width: 730px;

    @media (max-width: $breakpoint-md) {
      margin-bottom: $spacing-16;
    }
  }
}
.time-card {
  background: $color-surface-800;
  display: flex;
  border-radius: 16px;
  flex-direction: row;

  .img-wrapper {
    position: relative;
    max-width: 275px;
  }

  img {
    width: 100%;
    height: 100%;
    border-radius: 16px 0px 0px 16px;
    object-fit: cover;
    object-position: left;
  }

  .content {
    padding: $spacing-48;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    text-align: left;
  }

  .slp-btn {
    margin-bottom: $spacing-24;
    transition: all 0.2s ease-in-out;

    .slp-icon {
      margin-left: $spacing-8;
    }
    &:hover .slp-icon {
      margin-left: $spacing-16;
    }
  }

  @media (max-width: $breakpoint-md) {
    flex-direction: column;

    .img-wrapper {
      width: 100%;
      max-width: 100%;
    }
    img {
      border-radius: 16px 16px 0px 0px;
    }

    .content {
      padding: $spacing-32 $spacing-24;
    }

    .slp-btn {
      margin-bottom: 0;
    }
  }
}

.cards {
  display: flex;
  gap: $spacing-16;
  justify-content: space-between;
  margin-bottom: $spacing-48;

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
  }

  .card {
    flex: 1 0 50%;
    background: $color-surface-800;
    border-radius: 16px;
    padding: $spacing-32 80px $spacing-32 $spacing-32;
    color: $color-text-300;
    transition: all 0.3s ease-in-out;

    &:hover {
      box-shadow: $shadow-surface-primary-3;
    }

    span {
      display: flex;
      flex-wrap: nowrap;
      align-items: center;
      font-size: $text-button-1;
      line-height: $line-height-button-1;

      .slp-icon {
        margin-left: $spacing-8;
      }
    }

    h3 {
      margin-top: $spacing-16;
      margin-bottom: $spacing-24;
    }

    p {
      margin-right: $spacing-8;
    }
  }
}
</style>
